<?php
/**
 * 
 * 
 * 
 */

if (!defined('IN_COPPERMINE')) { die('Not in Coppermine...');}
if (!defined('JUPLOAD_PHP')) { die('Not in Jupload...');}

require ('plugins/jupload/include/j_catmgr.inc.php');


if (!USER_CAN_UPLOAD_PICTURES) {
    $msg = 
    	str_replace(
			'$1', 
			'login.php?referer=plugins/jupload/jupload.php', 
			$lang_jupload_php['perm_denied'])
		;
		
    cpg_die(ERROR, $msg, __FILE__, __LINE__);    
}

//####################################################################################################
//##############################  LOCAL VARIABLES   ##################################################
//####################################################################################################

$jarPath = $JUPLOAD_CONFIG['jarPath'] . "wjhk.jupload.jar";
$debugLevel = 0;
$URL = $CONFIG['site_url'] . 'index.php?file=jupload/jupload&action=add_picture';  
$urlToSendErrorTo = $CONFIG['site_url'] . 'index.php?file=jupload/jupload&action=log_error';
$highQualityPicture = ($JUPLOAD_CONFIG['highQualityPreview']   ?  'true' : 'false');

//Should we give a realMaxPictureWidth and realMaxPictureHeight to the applet ?
$maxNonTransformedPictureSize =  ($JUPLOAD_CONFIG['maxNonTransformedPictureSize'] < 0)
									? $CONFIG['max_upl_width_height']
									:  $JUPLOAD_CONFIG['maxNonTransformedPictureSize'];

//In PHP, we are limited to int, so maxChunkSize and maxFileSize are in kb. 
//In Java, these parameters are managed as long. So we transform these parameters to bytes
//Let's say that a kb is 1000 bytes ....
$maxFileSize =  $JUPLOAD_CONFIG['maxFileSize'] . '000';
if ($JUPLOAD_CONFIG['maxChunkSize'] == '') {
	//The default chunk size is the maximum file size.
	$maxChunkSize = $JUPLOAD_CONFIG['maxFileSize'] . '000';
} else {
	$maxChunkSize = $JUPLOAD_CONFIG['maxChunkSize'] . '000';
}

//The language code coming from Coppermine seems to be different from the Java one.
//e.g.: zh-cn for zh_CN (where I'm not really sure about CN)
$localLang = $lang_translation_info['lang_country_code'];
$nbPart = preg_match('/(..).(..)/', $localLang, $matches);
if ($nbPart == 1) {
	//If we arrive here, we have both a language code, and a country code. The correct syntax, in java, is:
	//ll_CC :
	$localLang = $matches[1] . '_' . strtoupper($matches[2]);
}

//Manage Basic HTTP Authentication
$specificHeaders = '';
if ($JUPLOAD_CONFIG['basicHttpAuthentication']) {
	$specificHeaders .= '<PARAM NAME = "specificHeaders" VALUE="Authorization: Basic ';
	$specificHeaders .= base64_encode($JUPLOAD_CONFIG['basicHttpAuthentication']);
	$specificHeaders .= '"> "';
}

/**
 * This is an empty applet, correctly converted by the java  html converter. It will prompt a message
 * to the user when Java is not installed on its computer, as Java is needed for this page.
 * The effective APPLET tag that loaded the real JUpload applet remains a simple APPLET tag, and 
 * is not converted by htmlConverter, to be easy to update.
 */
$emptyConvertedApplet = <<<EOS
<!--"CONVERTED_APPLET"-->
<!-- HTML CONVERTER -->
<script language="JavaScript" type="text/javascript"><!--
    var _info = navigator.userAgent;
    var _ns = false;
    var _ns6 = false;
    var _ie = (_info.indexOf("MSIE") > 0 && _info.indexOf("Win") > 0 && _info.indexOf("Windows 3.1") < 0);
//--></script>
    <comment>
        <script language="JavaScript" type="text/javascript"><!--
        var _ns = (navigator.appName.indexOf("Netscape") >= 0 && ((_info.indexOf("Win") > 0 && _info.indexOf("Win16") < 0 && java.lang.System.getProperty("os.version").indexOf("3.5") < 0) || (_info.indexOf("Sun") > 0) || (_info.indexOf("Linux") > 0) || (_info.indexOf("AIX") > 0) || (_info.indexOf("OS/2") > 0) || (_info.indexOf("IRIX") > 0)));
        var _ns6 = ((_ns == true) && (_info.indexOf("Mozilla/5") >= 0));
//--></script>
    </comment>

<script language="JavaScript" type="text/javascript"><!--
    if (_ie == true) document.writeln('<object classid="clsid:8AD9C840-044E-11D1-B3E9-00805F499D93" WIDTH = "0" HEIGHT = "0" NAME = "JUploadApplet"  codebase="http://java.sun.com/update/1.5.0/jinstall-1_5-windows-i586.cab#Version=5,0,0,3"><noembed><xmp>');
    else if (_ns == true && _ns6 == false) document.writeln('<embed ' +
	    'type="application/x-java-applet;version=1.5" \
            CODE = "wjhk.jupload2.EmptyApplet" \
            ARCHIVE = "$jarPath" \
            NAME = "JUploadApplet" \
            WIDTH = "0" \
            HEIGHT = "0" \
            type ="application/x-java-applet;version=1.6" \
            scriptable ="false" ' +
	    'scriptable=false ' +
	    'pluginspage="http://java.sun.com/products/plugin/index.html#download"><noembed><xmp>');
//--></script>
<applet  CODE = "wjhk.jupload2.EmptyApplet" ARCHIVE = "$jarPath" WIDTH = "0" HEIGHT = "0" NAME = "JUploadApplet"></xmp>
    <PARAM NAME = CODE VALUE = "wjhk.jupload2.EmptyApplet" >
    <PARAM NAME = ARCHIVE VALUE = "$jarPath" >
    <PARAM NAME = NAME VALUE = "JUploadApplet" >
    <param name="type" value="application/x-java-applet;version=1.5">
    <param name="scriptable" value="false">
    <PARAM NAME = "type" VALUE="application/x-java-applet;version=1.6">
    <PARAM NAME = "scriptable" VALUE="false">

</xmp>
    
Java 1.5 or higher plugin required.
</applet>
</noembed>
</embed>
</object>

<!--
<APPLET CODE = "wjhk.jupload2.EmptyApplet" ARCHIVE = "$jarPath" WIDTH = "0" HEIGHT = "0" NAME = "JUploadApplet">
	<PARAM NAME = "type" VALUE="application/x-java-applet;version=1.6">
	<PARAM NAME = "scriptable" VALUE="false">
	</xmp>
Java 1.5 or higher plugin required.
</APPLET>
-->
<!--"END_CONVERTED_APPLET"-->

EOS
;




//####################################################################################################
//#################################    FUNCTIONS    ##################################################
//####################################################################################################

//Insert an album into database, if the user is allowed to.
//The category is given into $cat. It's mandatory if the galery is in admin mode.
function create_album($album, $album_name, $album_description, $cat=0) {
  global $lang_errors, $CONFIG, $lang_jupload_php;
  if (!(GALLERY_ADMIN_MODE || USER_ADMIN_MODE)) {
  	cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
  }

  if ($album_name == '') cpg_die(ERROR, $lang_errors['param_missing'], __FILE__, __LINE__);

  if (GALLERY_ADMIN_MODE) {
    if ($cat <= 0) cpg_die(ERROR, $lang_errors['param_missing'], __FILE__, __LINE__);
    $category = $cat; 
    	//JUpload(int)$_POST['cat'];
  } else {
    $category = FIRST_USER_CAT + USER_ID;
  }

  //We first check that the user doesn't already own an album with this name in this category:
  $vQuery = "SELECT count(*) nb "
    		. " FROM {$CONFIG['TABLE_ALBUMS']} " 
    		. " WHERE category = '$category'"
    		. " AND   title = '" . addslashes($album_name) . "'";
  $vRes = cpg_db_query($vQuery);
  $vRes = mysql_fetch_array($vRes);
  if ($vRes['nb'] > 0) cpg_die(ERROR, $lang_jupload_php['error_album_already_exists'], __FILE__, __LINE__);

  //Let's insert the new album.
  $query = "INSERT INTO {$CONFIG['TABLE_ALBUMS']} (category, title, description, uploads, pos) "  
    . " SELECT '$category', '" . addslashes($album_name) . "', '" . addslashes($album_description) . "', 'NO',  IFNULL(MAX(pos),101) "
    . " FROM {$CONFIG['TABLE_ALBUMS']} WHERE category = '$category' ";
  cpg_db_query($query);
  
  //Now, we select its id, to redirect the user to this album.
  $vQuery = "SELECT aid "
    		. " FROM {$CONFIG['TABLE_ALBUMS']} " 
    		. " WHERE category = '$category'"
    		. " AND   title = '" . addslashes($album_name) . "'";
  $vRes = cpg_db_query($vQuery);
  $vRes = mysql_fetch_array($vRes);

  jupload_message_success("upload_page", $vRes['aid'], $cat);
}//create_album




//Update an album into database, if the user is allowed to.
function update_album($album, $album_name, $album_description) {
  global $lang_errors, $CONFIG, $lang_jupload_php, $lang_db_input_php, $category;
  
  
  if (!(GALLERY_ADMIN_MODE || USER_ADMIN_MODE)) {
  	cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
  }

  if (USER_ADMIN_MODE) {
    //The user may only update its own albums.
    $category = FIRST_USER_CAT + USER_ID;
    //EGR start:
    //$user_albums = cpg_db_query("SELECT 1 FROM ${CONFIG['TABLE_ALBUMS']} WHERE category = '$category'");
    $user_albums = cpg_db_query("SELECT 1 FROM ${CONFIG['TABLE_ALBUMS']} WHERE category = '$category' AND aid = $album");
    //EGR end
    if (! mysql_num_rows($user_albums)) {
      cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
    }
  } else {
  	//Check that the given category is correct.
  	$res_category = cpg_db_query("SELECT category FROM ${CONFIG['TABLE_ALBUMS']} WHERE aid=$album AND category=$category");
	if (mysql_num_rows($res_category) != 1) cpg_die(ERROR, $lang_db_input_php['unknown_album'], __FILE__, __LINE__);
	$res_category = mysql_fetch_array($res_category);
  }

  //Then, check that the user doesn't already own an album with this name
  $vQuery = "
  		SELECT count(*) nb
  		FROM {$CONFIG['TABLE_ALBUMS']}
  		WHERE category = '$category'
    	AND   title = '" . addslashes($album_name) . "'
    	AND   aid != $album
		";
  $vRes = cpg_db_query($vQuery);
  $vRes = mysql_fetch_array($vRes);
  if ($vRes['nb'] > 0) cpg_die(ERROR, $lang_jupload_php['error_album_already_exists'], __FILE__, __LINE__);

  $query = "UPDATE {$CONFIG['TABLE_ALBUMS']} SET title='" . addslashes($album_name) 
  	. "', description='" . addslashes($album_description) . "' WHERE aid=$album $restrict LIMIT 1";
  cpg_db_query($query);
  jupload_message_success("upload_page", $album, $category);
}//update_album



/**
 * Prepares a string so that is can be stored ... in a js string
 */
function prepare_js_string($str) {
	return 	
		str_replace("\r", "",
			str_replace("\n", "\\n",
				str_replace("'", "\\'", 
					html_entity_decode($str) 
				)
			)
		);
}

/**
 * displays a string description[album_id] = 'album_desc';  on the standard output.
 * This is used to store all album descriptions in a javascript array. 
 * See below.
 */
function echo_jsarray_description($album_list) {
	foreach($album_list as $a) {
		echo ("  description[{$a['aid']}] = '" . prepare_js_string($a['description']) . "';\n");
	}//foreach
}//echo_jsarray_description


/**
 * This function initialize the relevant information, so that the user may change of category and album
 * without resubmitting the form.
 * Submitting is bad as ... it reloads the applet, erasing any work done by the user (as selecting and rotating
 * pictures).
 */
function echo_jsarray_category_albums() {
	
	//This function put all he site arborescence in the JavaScript. It's allowed only in GALLERY_ADMIN_MODE'
	//This should not arrive, as this function is only caled if we are in this mode, so this is just a double-check
	//and I directly call the cpg_die method. 
	if (!GALLERY_ADMIN_MODE) {
		cpg_die("Internal error in echo_jsarray_category_albums");
	}
	
	$sql =  "SELECT category, aid, title " .
			"FROM {$CONFIG['TABLE_ALBUMS']} " .
			"WHERE parent = '$parent' " .
			"ORDER BY pos";
	$result = cpg_db_query($sql);
	$rowset = cpg_db_fetch_rowset($result);
	foreach ($rowset as $subcat) {
		if (!isset($next_indice[$rowset['category']])) {
			$next_indice[$rowset['category']] = 0;
		} else {
			$next_indice[$rowset['category']] += 1;
		}
		echo ("category_to_album[${rowset['category']}][" . $next_indice[$rowset['category']] 
			. "]  =  ${rowset['aid']};\n");
		echo ("album_title[{$rowset['aid']}] = '" . prepare_js_string($rowset['title']) . "';\n");
	}//foreach
}//echo_jsarray_category_albums

///////////////////////////////////////////////////////////////////////
/////////////////   ALBUM MANAGEMENT (if post data)  //////////////////
///////////////////////////////////////////////////////////////////////

switch ($action) {
case 'update_album':
	update_album($album, $album_name, $album_description, $category);
	break;
case 'create_album';
	create_album($album, $album_name, $album_description, $category);
	break;
}


///////////////////////////////////////////////////////////////////////
/////////////////   GENERATING THE HTML CONTENT    ////////////////////
///////////////////////////////////////////////////////////////////////

pageheader($lang_jupload_php['link_title']);

///////////////////////////////////////////////////////////////////////
//First part : some local javascript
///////////////////////////////////////////////////////////////////////

//Initialization, let's prepare the creation of the desc array : what's the bigguest album number ?
$max = 0;
foreach($user_albums_list as $a) {
  if ($a['aid'] >= $max) {
    $max = $a['aid'] + 1;
  }
}//foreach
foreach($public_albums_list as $a) {
  if ($a['aid'] >= $max) {
    $max = $a['aid'] + 1;
  }
}//foreach

//$error_select_album = rawurlencode(html_entity_decode($lang_jupload_php['error_select_album']));
//$error_album_name   = rawurlencode(html_entity_decode($lang_jupload_php['error_album_name'  ]));

//Tests to try the best way to encode decode strings
$error_select_album = addslashes($lang_jupload_php['error_select_album']);
$error_album_name = addslashes($lang_jupload_php['error_album_name']);



//Add of the javascript function that will check that java is enabled.
//addJSJavaCheck();

echo <<<EOS
  <script language="javascript" type="text/javascript">
  
  //Check if an album is selected. 
  //The first line may be the 'select an album'
  
  //What should we do, when the user selects another album ?
  function onAlbumChange() {
    if (document.form_album.album.selectedIndex > 0) {
      //document.applets['JUpload'].setProperty('albumId', document.form_album.album.value);
      document.JUpload.setProperty('albumId', document.form_album.album.value);
      document.form_album.album_name.value = document.form_album.album.options[document.form_album.album.selectedIndex].text;
      document.form_album.album_description.value = description[document.form_album.album.value];
    } else {
      document.JUpload.setProperty('albumId', '');
      document.form_album.album_name.value = '';
      document.form_album.album_description.value = '';
    }
  }
  function juploadAddPicture() {
  	if (document.form_album.album_name.value == '') {
  		alert(unescape('{$error_select_album}'));
  	} else {
	  	window.location='#applet';
  	}
	//In any case, the  submit must be refused.
	return false;
  }
  function juploadCreateAlbum() {
  	if (document.form_album.album_name.value == '') {
  		alert(unescape('{$error_album_name}'));
  		return false;
  	} else {	
	    document.form_album.action.value = 'create_album';
	    return true;
  	}	    
  }
  function juploadUpdateAlbum() {
  	if (document.form_album.album.selectedIndex == 0) {
  		alert(unescape('{$error_select_album}'));
  		return  false;
  	} else if (document.form_album.album_name.value == '') {
  		alert(unescape('{$error_album_name}'));
  		return false;
  	} else {
	    document.form_album.action.value = 'update_album';
	    return true;
  	}
  }
    
  //Creation of the album description aray.
  description = new Array($max);

EOS
;

	//Initialization, let's prepare the creation of the desc array
	$max = 0;
	echo_jsarray_description($user_albums_list);
	echo_jsarray_description($public_albums_list);
	
	/*
	 * Almost ready ... for a next version
	 * 
	 * I must be able to reload a Select contrl, without reload the form. 
	 * 
	//In admin mode, we store all categories, and their albums in javascript arrays, so that
	//it is useless to reload the page when the user changes the current category.
	if (!GALLERY_ADMIN_MODE) {
		echo_jsarray_category_albums();
	}
	*/

	//If the page is refreshed, the navigator may keep the current album selection in the list,
	//but the album is not selected in the applet. Let's deselect the album in the list, when running this
	//page. I'll find a better solution, later.
echo <<<EOS
  </script>
EOS
;

///////////////////////////////////////////////////////////////////////
//Second part : the selection of the category or album
///////////////////////////////////////////////////////////////////////


		//Let's start the real page content.
		starttable("100%", $lang_jupload_php['select_album'], 2);
		
		//Some lobying message about translation.
		if (! $bJuploadTranslactionExist) {
			form_statement ('<B><I>The JUpload translation for this language doesn\'t exist. </B>'
				. 'If you want to create it, please go to the <a href="http://etienne.lesgauthier.fr/wiki/doku.php?id=jupload_translation">JUpload translation page</a>.</I>'
				);
		}	
		form_statement ($lang_jupload_php['album_presentation']);
		
		///////////////////////////////////////////////////////////////////////
		//In admin mode, the user must first choose the category.
		if (GALLERY_ADMIN_MODE) {
			j_get_subcat_data(0);
			//$current_category = array('cid' => '0', 'name' => '', 'parent' => '0', 'description' => '');
			//$lb = cat_list_box($current_category['parent'], $current_category['cid'], false);
			form_html(
				'<form method="get" '
					. 'name="form_category" '
					. "action='${JUPLOAD_VAR['SELF']}'>"
					. "<input type='hidden' name='file' value='jupload/jupload'>"
					. "<input type='hidden' name='action' value='upload_page'>"
				. j_cat_list_box($current_category['cid'], $current_category['cid'], false, 'category', 'onChange="form_category.submit();"')
				. '</form>'
				, 
				$lang_cat_list['category']);
		}

		//////////////////////////////////////////////////////////////////////////
		//Start of the main HTML form.
		form_html('<form method="post" name="form_album" enctype="multipart/form-data" action="index.php?file=jupload/jupload&action=upload_page">' .
				"<input type='hidden' name='category' value='$category'>");
		if (GALLERY_ADMIN_MODE) {
			if (isset($category)) {
				form_cat_alb_list_box($category, $album, $lang_jupload_php['album'], "album", 'onChange="onAlbumChange()"');
			}
		//In non admin mode, we just display the album list, where the user may upload pictures.
		} else {
			form_alb_list_box ($lang_jupload_php['album'], "album", 'onChange="onAlbumChange()"');
		}
		hidden_input('action', 'no action');
				
		//Now, the album title and description input areas.
		text_box_input($lang_jupload_php['album_name'], 'album_name', 255, 1, (($album>0)?$album_name:'')); 
		text_area_input($lang_jupload_php['album_description'], 'album_description', 2000, (($album>0)?$album_description:''));
		$submit_buttons = array (
			    array( 'value'  =>  $lang_jupload_php['add_pictures'], 'js' => 'onClick="return juploadAddPicture()"')
		    );
		//In USER_ADMIN_MODE, the user may create albums: the creation will be in its own gallery.
		//In GALLERY_ADMIN_MODE, the user must have choosen a category before creating a new album.
		if (USER_ADMIN_MODE  ||  (GALLERY_ADMIN_MODE && $category>0)) {
			$submit_buttons[] = array('value'  =>  $lang_jupload_php['button_update_album'], 'js' => 'onClick="return juploadUpdateAlbum()"');
			$submit_buttons[] = array( 'value'  =>  $lang_jupload_php['button_create_album'], 'js' => 'onClick="return juploadCreateAlbum()"');
		}
		submit_button($submit_buttons);
	endtable();
echo ("</form>");


///////////////////////////////////////////////////////////////////////
//Third part : the upload applet
///////////////////////////////////////////////////////////////////////

starttable("100%", '<a name="applet"></a>'.$lang_jupload_php['add_pictures'], 2);

	form_label ($lang_jupload_php['max_upload_size'], $CONFIG['max_upl_size']);
	form_statement ($lang_jupload_php['upload_presentation']);
	/*
	 * Below : use of the standard applet tag for all. This is simpler, and seems to work better ... now. This
	 * was probably wrong when the original jupload was released, in 2002. 
	 */
	form_label (<<<EOS
  	<CENTER>
$emptyConvertedApplet
<APPLET CODE = "wjhk.jupload2.JUploadApplet" ARCHIVE = "$jarPath" WIDTH = "640" HEIGHT = "450" NAME = "JUpload" MAYSCRIPT = true>
	<PARAM NAME = "albumId" VALUE="$album">
	<PARAM NAME = "allowedFileExtensions" VALUE="${CONFIG['allowed_file_extensions']}">
	<PARAM NAME = "allowHttpPersistent" VALUE="false">
	<PARAM NAME = "debugLevel" VALUE="$debugLevel">
	<PARAM NAME = "lang" VALUE="$localLang">
	<PARAM NAME = "highQualityPreview" VALUE="$highQualityPicture">
	<PARAM NAME = "maxFileSize" VALUE="$maxFileSize">
	<PARAM NAME = "maxChunkSize" VALUE="$maxChunkSize">
	<PARAM NAME = "maxPicHeight" VALUE="$maxNonTransformedPictureSize">
	<PARAM NAME = "maxPicWidth" VALUE="$maxNonTransformedPictureSize">
	<PARAM NAME = "pictureCompressionQuality" VALUE="${JUPLOAD_CONFIG['pictureCompressionQuality']}">
	<PARAM NAME = "realMaxPicHeight" VALUE="${CONFIG['max_upl_width_height']}">
	<PARAM NAME = "realMaxPicWidth" VALUE="${CONFIG['max_upl_width_height']}">
	<PARAM NAME = "nbFilesPerRequest" VALUE="1">
	<PARAM NAME = "postURL" VALUE="$URL">
	<PARAM NAME = "serverProtocol" VALUE="${_SERVER['SERVER_PROTOCOL']}">
$specificHeaders
	<PARAM NAME = "showLogWindow" VALUE="false">
	<PARAM NAME = "stringUploadSuccess" VALUE="SUCCESS">
	<PARAM NAME = "uploadPolicy" VALUE="CoppermineUploadPolicy">
	<PARAM NAME = "urlToSendErrorTo" VALUE="$urlToSendErrorTo">
Java 1.5 or higher plugin required.
</APPLET>
   </CENTER>

EOS
);

form_statement("JUpload plugin for Coppermine v " . $JUPLOAD_CONFIG['version'] . 
	', available at <a href="http://etienne.lesgauthier.fr/wiki/doku.php?id=jupload_coppermine_download_gb">'
	. 'http://etienne.lesgauthier.fr/wiki/doku.php?id=jupload_coppermine_download_gb</a>');

endtable();


//Some controls, to be done at the end of the page generation.
echo "
<script language='javascript'>
";
if ($album > 0) {
	//Let's say to the applet which album is selected.
	echo("document.applets['JUpload'].setProperty('albumId', ${album});
");
} else {
	//No album selected. We clear the list. It's useful if the user click on 'Refresh': the list is cleared, but
	//the album name and descriptions are filled.
	echo "
			document.form_album.album.selectedIndex = 0;
			onAlbumChange();
	";
}
echo ("
document.applets['JUpload'].displayInfo('JUpload plugin for coppermine version ${JUPLOAD_CONFIG['version']}');
</script>
");

pagefooter();
//ob_end_flush();

